Index: tmp/org.txm.index.core/src/org/txm/index/core/preferences/IndexPreferences.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/preferences/IndexPreferences.java	(revision 1025)
+++ tmp/org.txm.index.core/src/org/txm/index/core/preferences/IndexPreferences.java	(revision 1026)
@@ -1,8 +1,6 @@
 package org.txm.index.core.preferences;
 
 
-import org.eclipse.core.runtime.preferences.DefaultScope;
-import org.osgi.framework.FrameworkUtil;
 import org.osgi.service.prefs.Preferences;
 import org.txm.core.preferences.TXMPreferences;
 
@@ -14,23 +12,32 @@
  */
 public class IndexPreferences extends TXMPreferences {
 
-	public static final String PREFERENCES_NODE = FrameworkUtil.getBundle(IndexPreferences.class).getSymbolicName();
-	
-	
 	/**
 	 * 
 	 */
 	public static final String PROPERTIES_SEPARATOR = "properties_separator"; //$NON-NLS-1$
 	
 	/**
-	 * 
+	 * Number of the line of the current page.
 	 */
 	public static final String N_TOP_INDEX = "n_top_index"; //$NON-NLS-1$
 
+	/**
+	 * Gets the instance.
+	 * @return the instance
+	 */
+	public static TXMPreferences getInstance()	{
+		if (!TXMPreferences.instances.containsKey(IndexPreferences.class)) {
+			new IndexPreferences();
+		}
+		return TXMPreferences.instances.get(IndexPreferences.class);
+	}
+
+	
 	@Override
 	public void initializeDefaultPreferences() {
 	
-		Preferences preferences = DefaultScope.INSTANCE.getNode(PREFERENCES_NODE);
+		Preferences preferences = this.getDefaultPreferencesNode();
 		preferences.put(UNIT_PROPERTIES, DEFAULT_UNIT_PROPERTY); //$NON-NLS-1$
 		preferences.put(UNIT_PROPERTY, DEFAULT_UNIT_PROPERTY); //$NON-NLS-1$
 		preferences.put(PROPERTIES_SEPARATOR, "_"); //$NON-NLS-1$
Index: tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/preferences/LexicalTablePreferencePage.java
===================================================================
--- tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/preferences/LexicalTablePreferencePage.java	(revision 1025)
+++ tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/preferences/LexicalTablePreferencePage.java	(revision 1026)
@@ -63,7 +63,7 @@
 
 	@Override
 	public void init(IWorkbench workbench) {
-		this.setPreferenceStore(new TXMPreferenceStore(LexicalTablePreferences.PREFERENCES_NODE));
+		this.setPreferenceStore(new TXMPreferenceStore(LexicalTablePreferences.getInstance().getPreferencesNodeQualifier()));
 		this.setTitle(LexicalTableCoreMessages.RESULT_TYPE);
 		this.setImageDescriptor(LexicalTableAdapterFactory.ICON);
 	}
Index: tmp/org.txm.ahc.rcp/src/org/txm/ahc/rcp/handlers/ComputeAHC.java
===================================================================
--- tmp/org.txm.ahc.rcp/src/org/txm/ahc/rcp/handlers/ComputeAHC.java	(revision 1025)
+++ tmp/org.txm.ahc.rcp/src/org/txm/ahc/rcp/handlers/ComputeAHC.java	(revision 1026)
@@ -41,7 +41,6 @@
 import org.txm.ca.core.functions.CA;
 import org.txm.ca.core.preferences.CAPreferences;
 import org.txm.ca.rcp.editors.CAParametersDialog;
-import org.txm.ca.rcp.messages.CAUIMessages;
 import org.txm.chartsengine.rcp.editors.ChartEditor;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TXMPreferences;
@@ -108,8 +107,8 @@
 			}
 			try {
 				String title = AHCUIMessages.bind(AHCUIMessages.ComputeCAH_0, partition.getName());
-				int vMax = TXMPreferences.getInt(TXMPreferences.V_MAX, CAPreferences.PREFERENCES_NODE);
-				int fMin = TXMPreferences.getInt(TXMPreferences.F_MIN, CAPreferences.PREFERENCES_NODE);
+				int vMax = CAPreferences.getInstance().getInt(TXMPreferences.V_MAX);
+				int fMin =  CAPreferences.getInstance().getInt(TXMPreferences.F_MIN);
 				Shell shell = Display.getCurrent().getActiveShell();
 				CAParametersDialog d = new CAParametersDialog(shell, partition.getParent(), title);
 				d.setFminAndVMax(fMin, vMax);
Index: tmp/org.txm.ahc.rcp/src/org/txm/ahc/rcp/preferences/AHCPreferencePage.java
===================================================================
--- tmp/org.txm.ahc.rcp/src/org/txm/ahc/rcp/preferences/AHCPreferencePage.java	(revision 1025)
+++ tmp/org.txm.ahc.rcp/src/org/txm/ahc/rcp/preferences/AHCPreferencePage.java	(revision 1026)
@@ -88,7 +88,7 @@
 
 	@Override
 	public void init(IWorkbench workbench) {
-		this.setPreferenceStore(new TXMPreferenceStore(AHCPreferences.PREFERENCES_NODE));
+		this.setPreferenceStore(new TXMPreferenceStore(AHCPreferences.getInstance().getPreferencesNodeQualifier()));
 		//setDescription("AHC");
 		this.setTitle(AHCCoreMessages.RESULT_TYPE);
 		this.setImageDescriptor(AHCAdapterFactory.ICON);
Index: tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/TreeTaggerEngine.java
===================================================================
--- tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/TreeTaggerEngine.java	(revision 1025)
+++ tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/TreeTaggerEngine.java	(revision 1026)
@@ -20,19 +20,19 @@
 	@Override
 	public boolean isRunning() {
 		
-		ttBinaryDirectory = new File(TreeTaggerPreferences.getString(TreeTaggerPreferences.INSTALL_PATH, TreeTaggerPreferences.PREFERENCES_NODE)+"/bin/");
+		ttBinaryDirectory = new File(TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.INSTALL_PATH)+"/bin/");
 		if (!ttBinaryDirectory.exists()) {
 			System.out.println("Error: path to TreeTagger is wrong: "+ttBinaryDirectory);
 			return false;
 		}
 		
-		ttModelsDirectory = new File(TreeTaggerPreferences.getString(TreeTaggerPreferences.MODELS_PATH, TreeTaggerPreferences.PREFERENCES_NODE));
+		ttModelsDirectory = new File(TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.MODELS_PATH));
 		if (!ttModelsDirectory.exists()) {
 			System.out.println("Error: path to TreeTagger path is wrong: "+ttModelsDirectory);
 			return false;
 		}
 		
-		options = TreeTaggerPreferences.getString(TreeTaggerPreferences.OPTIONS, TreeTaggerPreferences.PREFERENCES_NODE).split("  ");
+		options = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.OPTIONS).split("  ");
 		
 		return ttBinaryDirectory != null && ttBinaryDirectory.exists() && ttModelsDirectory != null && ttModelsDirectory.exists();
 	}
Index: tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/preferences/TreeTaggerPreferences.java
===================================================================
--- tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/preferences/TreeTaggerPreferences.java	(revision 1025)
+++ tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/preferences/TreeTaggerPreferences.java	(revision 1026)
@@ -7,8 +7,6 @@
 import java.net.URL;
 import java.util.Properties;
 
-import org.eclipse.core.runtime.preferences.DefaultScope;
-import org.osgi.framework.FrameworkUtil;
 import org.osgi.framework.Version;
 import org.osgi.service.prefs.Preferences;
 import org.txm.core.preferences.TXMPreferences;
@@ -25,39 +23,47 @@
 public class TreeTaggerPreferences extends TXMPreferences {
 
 
-	// auto populate the preference node qualifier from the current bundle id
-	public static final String PREFERENCES_NODE = FrameworkUtil.getBundle(TreeTaggerPreferences.class).getSymbolicName();
-	
-	public static final String PREFERENCES_PREFIX = "treetagger_"; //$NON-NLS-1$
-
 	/**
 	 * contains the last bundle version setting the TreeTagger binariesl directory
 	 */
-	public static final String INSTALLED_BINARIES_VERSION = PREFERENCES_PREFIX + "installed_binaries_version"; //$NON-NLS-1$
+	public static final String INSTALLED_BINARIES_VERSION = "installed_binaries_version"; //$NON-NLS-1$
 	/**
 	 * contains the last bundle version setting the TreeTagger models directory
 	 */
-	public static final String INSTALLED_MODELS_VERSION = PREFERENCES_PREFIX + "installed_models_version"; //$NON-NLS-1$
+	public static final String INSTALLED_MODELS_VERSION = "installed_models_version"; //$NON-NLS-1$
 	
 	/**
 	 * Installation path.
 	 */
-	public static final String INSTALL_PATH = PREFERENCES_PREFIX + "install_path"; //$NON-NLS-1$
+	public static final String INSTALL_PATH = "install_path"; //$NON-NLS-1$
 
 	/**
 	 * Models path.
 	 */
-	public static final String MODELS_PATH = PREFERENCES_PREFIX + "models_path"; //$NON-NLS-1$
+	public static final String MODELS_PATH = "models_path"; //$NON-NLS-1$
 	
-	public static final String OPTIONS = PREFERENCES_PREFIX + "options"; //$NON-NLS-1$
+	public static final String OPTIONS = "options"; //$NON-NLS-1$
 	
-	public static final String FIX_APOSTROPHES = PREFERENCES_PREFIX + "fix_apostrophes"; //$NON-NLS-1$
+	public static final String FIX_APOSTROPHES = "fix_apostrophes"; //$NON-NLS-1$
 
+	
+	/**
+	 * Gets the instance.
+	 * @return the instance
+	 */
+	public static TXMPreferences getInstance()	{
+		if (!TXMPreferences.instances.containsKey(TreeTaggerPreferences.class)) {
+			new TreeTaggerPreferences();
+		}
+		return TXMPreferences.instances.get(TreeTaggerPreferences.class);
+	}
+
+	
 	@Override
 	public void initializeDefaultPreferences() {
 
 		// Default preferences if no org.txm.treetagger.core fragment is found
-		Preferences preferences = DefaultScope.INSTANCE.getNode(PREFERENCES_NODE);
+		Preferences preferences = this.getDefaultPreferencesNode();
 		
 		String installPath = "/usr/lib/treetagger"; //"System.getProperty("osgi.user.area") + "/TXM/treetagger"; //$NON-NLS-1$ //$NON-NLS-2$
 		if (System.getProperty("os.name").contains("Windows")) {
@@ -71,8 +77,8 @@
 		preferences.putBoolean(FIX_APOSTROPHES, false);
 
 		// FIXME: need to validate this code + need to check if it's still useful
-		String bversion = TXMPreferences.getString(INSTALLED_BINARIES_VERSION, PREFERENCES_NODE);
-		String mversion = TXMPreferences.getString(INSTALLED_MODELS_VERSION, PREFERENCES_NODE);
+		String bversion = TreeTaggerPreferences.getInstance().getString(INSTALLED_BINARIES_VERSION);
+		String mversion = TreeTaggerPreferences.getInstance().getString(INSTALLED_MODELS_VERSION);
 		
 		// if TXM is launch for the first time bversion and mversion valus are empty
 		if (bversion == null || bversion.equals("") || mversion == null || mversion.equals("")) {
@@ -95,7 +101,7 @@
 					for (String k : keys) {
 						if (previousProperties.getProperty(previousProperties.getProperty(k)) != null) {
 							preferences.put(k, installPath);
-							TreeTaggerPreferences.put(PREFERENCES_NODE, k, previousProperties.getProperty(k));
+							TreeTaggerPreferences.getInstance().put(k, previousProperties.getProperty(k));
 						}
 					}
 				}
@@ -104,11 +110,11 @@
 				}
 			}
 			
-			TreeTaggerPreferences.put(PREFERENCES_NODE, INSTALLED_BINARIES_VERSION, "0.0.0");
-			TreeTaggerPreferences.put(PREFERENCES_NODE, INSTALLED_MODELS_VERSION, "0.0.0");
+			TreeTaggerPreferences.getInstance().put(INSTALLED_BINARIES_VERSION, "0.0.0");
+			TreeTaggerPreferences.getInstance().put(INSTALLED_MODELS_VERSION, "0.0.0");
 			
-			bversion = TXMPreferences.getString(INSTALLED_BINARIES_VERSION, PREFERENCES_NODE);
-			mversion = TXMPreferences.getString(INSTALLED_MODELS_VERSION, PREFERENCES_NODE);
+			bversion = TreeTaggerPreferences.getInstance().getString(INSTALLED_BINARIES_VERSION);
+			mversion = TreeTaggerPreferences.getInstance().getString(INSTALLED_MODELS_VERSION);
 		}
 		
 		// look for org.txm.treetagger.core.<osname> fragment
@@ -138,7 +144,7 @@
 				new File(binariesDir, "bin/tree-tagger").setExecutable(true); // linux&mac
 				new File(binariesDir, "bin/train-tree-tagger").setExecutable(true); // linux&mac
 				preferences.put(INSTALL_PATH, binariesDir.getAbsolutePath());
-				TreeTaggerPreferences.put(PREFERENCES_NODE, INSTALLED_BINARIES_VERSION, binariesFragmentVersion.toString());
+				TreeTaggerPreferences.getInstance().put(INSTALLED_BINARIES_VERSION, binariesFragmentVersion.toString());
 				System.out.println("Done.");
 			} catch (MalformedURLException e) {
 				// TODO Auto-generated catch block
@@ -155,7 +161,7 @@
 				if (path.startsWith("file:")) path = path.substring(5);
 				File modelsDir = new File(path, "res/models");
 				preferences.put(MODELS_PATH, modelsDir.getAbsolutePath()); //$NON-NLS-1$
-				TreeTaggerPreferences.put(PREFERENCES_NODE, INSTALLED_MODELS_VERSION, modelsFragmentVersion.toString());
+				TreeTaggerPreferences.getInstance().put(INSTALLED_MODELS_VERSION, modelsFragmentVersion.toString());
 				System.out.println("Done.");
 			} catch (MalformedURLException e) {
 				// TODO Auto-generated catch block
Index: tmp/org.txm.properties.core/src/org/txm/properties/core/functions/Properties.java
===================================================================
--- tmp/org.txm.properties.core/src/org/txm/properties/core/functions/Properties.java	(revision 1025)
+++ tmp/org.txm.properties.core/src/org/txm/properties/core/functions/Properties.java	(revision 1026)
@@ -38,6 +38,7 @@
 import java.util.Locale;
 
 import org.eclipse.osgi.util.NLS;
+import org.txm.Toolbox;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.core.results.Parameter;
@@ -612,7 +613,7 @@
 		this.stepStructuralUnits();
 		this.worked(1);
 		
-		String txmhome = TXMPreferences.getString(TBXPreferences.USER_TXM_HOME, TBXPreferences.PREFERENCES_NODE);
+		String txmhome = Toolbox.getTxmHomePath();
 		String filename = corpus.getMainCorpus() + "-" + corpus.getName(); //$NON-NLS-1$
 		if (corpus instanceof MainCorpus) {
 			filename = corpus.getName(); //$NON-NLS-1$
Index: tmp/org.txm.treetaggerinstaller.rcp/src/org/txm/treetagger/DoInstallStep.java
===================================================================
--- tmp/org.txm.treetaggerinstaller.rcp/src/org/txm/treetagger/DoInstallStep.java	(revision 1025)
+++ tmp/org.txm.treetaggerinstaller.rcp/src/org/txm/treetagger/DoInstallStep.java	(revision 1026)
@@ -63,12 +63,12 @@
 		File OSDir = new File(treetaggerDir, os);
 		final File treetaggerModelsDir = new File(treetaggerDir, "models");
 
-		TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TreeTaggerPreferences.INSTALL_PATH, OSDir.getAbsolutePath());
+		TreeTaggerPreferences.getInstance().put(TreeTaggerPreferences.INSTALL_PATH, OSDir.getAbsolutePath());
 		
-		final String previousModelDirectoryPath = TXMPreferences.getString(TreeTaggerPreferences.MODELS_PATH, TBXPreferences.PREFERENCES_NODE);
+		final String previousModelDirectoryPath = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.MODELS_PATH);
 		if (previousModelDirectoryPath == null) {
 			Log.info("Set TreeTagger model directory to: "+treetaggerModelsDir);
-			TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TreeTaggerPreferences.MODELS_PATH, treetaggerModelsDir.getAbsolutePath());
+			TreeTaggerPreferences.getInstance().put(TreeTaggerPreferences.MODELS_PATH, treetaggerModelsDir.getAbsolutePath());
 		} else if (previousModelDirectoryPath.equals(treetaggerModelsDir.getAbsolutePath())) {
 			// nothing to do	
 			Log.info("No change to TreeTagger model directory.");
@@ -94,24 +94,24 @@
 						boolean b = MessageDialog.openConfirm(shell, "TreeTagger model directory", "The TreeTagger model directory is already set in TXM preferences and is not empty: \n  - "+StringUtils.join(filenames, "\n  - ")+"\n\nKeep using this one ?\n("+previousModelDirectoryPath+")");
 						if (!b) {
 							Log.info("Set TreeTagger model directory to: "+treetaggerModelsDir);
-							TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TreeTaggerPreferences.MODELS_PATH, treetaggerModelsDir.getAbsolutePath());
+							TreeTaggerPreferences.getInstance().put(TreeTaggerPreferences.MODELS_PATH, treetaggerModelsDir.getAbsolutePath());
 						} else {
 							Log.info("Keep TreeTagger model directory to: "+previousModelDirectoryDirectory);
 						}
 					}
 				});
 			} else {
-				TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TreeTaggerPreferences.MODELS_PATH, treetaggerModelsDir.getAbsolutePath());
+				TreeTaggerPreferences.getInstance().put(TreeTaggerPreferences.MODELS_PATH, treetaggerModelsDir.getAbsolutePath());
 			}
 		}
 		
-		String ttdir = TXMPreferences.getString(TreeTaggerPreferences.INSTALL_PATH, TBXPreferences.PREFERENCES_NODE);
-		String ttmodeldir = TXMPreferences.getString(TreeTaggerPreferences.MODELS_PATH, TBXPreferences.PREFERENCES_NODE);
+		String ttdir = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.INSTALL_PATH);
+		String ttmodeldir = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.MODELS_PATH);
 		Log.warning("TreeTagger preferences set to: "+ttdir+ " and "+ttmodeldir);
 		TXMPreferences.put(TreeTaggerInstallerPreferences.PREFERENCES_NODE, TreeTaggerInstallerPreferences.VERSION, currentVersion.toString());
 		
 		//FIXME: to beremoved when 0.8.0 preferences are ready 
-		TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TreeTaggerPreferences.INSTALL_PATH, ttdir);
-		TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TreeTaggerPreferences.MODELS_PATH, ttmodeldir);
+		TreeTaggerPreferences.getInstance().put(TreeTaggerPreferences.INSTALL_PATH, ttdir);
+		TreeTaggerPreferences.getInstance().put(TreeTaggerPreferences.MODELS_PATH, ttmodeldir);
 	}
 }
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/preferences/IndexPreferencesPage.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/preferences/IndexPreferencesPage.java	(revision 1025)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/preferences/IndexPreferencesPage.java	(revision 1026)
@@ -8,12 +8,18 @@
 import org.txm.rcp.preferences.TXMPreferencePage;
 import org.txm.rcp.preferences.TXMPreferenceStore;
 
+/**
+ * Index preferences page.
+ * 
+ * @author sjacquot
+ *
+ */
 public class IndexPreferencesPage extends TXMPreferencePage {
 
 	@Override
 	public void init(IWorkbench workbench) {
 		
-		this.setPreferenceStore(new TXMPreferenceStore(IndexPreferences.PREFERENCES_NODE));
+		this.setPreferenceStore(new TXMPreferenceStore(IndexPreferences.getInstance().getPreferencesNodeQualifier()));
 		this.setTitle("Index");
 		this.setImageDescriptor(IndexAdapterFactory.ICON);
 	}
Index: tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/preferences/AnnotationPreferencePage.java
===================================================================
--- tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/preferences/AnnotationPreferencePage.java	(revision 1025)
+++ tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/preferences/AnnotationPreferencePage.java	(revision 1026)
@@ -74,7 +74,7 @@
 	 */
 	@Override
 	public void init(IWorkbench workbench) {
-		this.setPreferenceStore(new TXMPreferenceStore(AnnotationPreferences.PREFERENCES_NODE));
+		this.setPreferenceStore(new TXMPreferenceStore(AnnotationPreferences.getInstance().getPreferencesNodeQualifier()));
 		//this.setTitle("WordCloud");
 		this.setImageDescriptor(IImageKeys.getImageDescriptor(IImageKeys.PENCIL));
 	}
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java	(revision 1025)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java	(revision 1026)
@@ -76,21 +76,10 @@
 	/** The Constant serialVersionUID. */
 	private static final long serialVersionUID = 4420732757687971253L;
 
-	/**
-	 * Get the safe values (spacial char regexp safe).
-	 *
-	 * @param property the property
-	 * @param corpus the corpus
-	 * @return the safe values
-	 * @throws CqiClientException the cqi client exception
-	 */
-	private static List<String> getSafeValues(StructuralUnitProperty property, Corpus corpus) throws CqiClientException	{
-		List<String> values = property.getValues(corpus);
-		for(int i = 0 ; i < values.size() ; i++)
-			values.set(i, Query.addBackSlash(values.get(i)));
-		return values;
-	}
+	/** sum of parts size, stored for efficiency reasons**/
+	int totalsize = -1;
 
+	
 	/** The property, if not null the partition will forge its own queries */
 	@Parameter(key=TXMPreferences.STRUCTURAL_UNIT_PROPERTY)
 	protected StructuralUnitProperty pProperty;
@@ -107,15 +96,13 @@
 	/**
 	 * the parts names -> do the parts order
 	 */
-	@Parameter(key=CQPPreferences.PARTNAMES)
+	@Parameter(key=CQPPreferences.PART_NAMES)
 	protected List<String> pPartNames;
 	/**
 	 * the partition name to set
 	 */
 	@Parameter(key=TXMPreferences.LAZY_NAME)
 	protected String pName;
-	/** sum of parts size, stored for efficiency reasons**/
-	int totalsize = -1;
 
 
 	//	/**
@@ -458,6 +445,7 @@
 	 * @return the the number of parts.
 	 */
 	public int getNPart() {
+		// FIXME: later should just return the direct children count
 		try {
 			if (!hasBeenComputedOnce()) {
 				compute();
@@ -713,7 +701,7 @@
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
 		this.pName = parameters.getString(TXMPreferences.LAZY_NAME);
-		String tmp = parameters.getString(CQPPreferences.PARTNAMES);
+		String tmp = parameters.getString(CQPPreferences.PART_NAMES);
 		if (tmp != null) {
 			this.pPartNames = Arrays.asList(tmp.split("\t"));
 		} else {
@@ -758,7 +746,7 @@
 			e.printStackTrace();
 		}
 		
-		tmp = this.getStringParameterValue(CQPPreferences.PARTNAMES);
+		tmp = this.getStringParameterValue(CQPPreferences.PART_NAMES);
 		if (tmp != null) {
 			this.pPartNames = Arrays.asList(tmp.split("\t"));
 		} else {
@@ -789,7 +777,7 @@
 		}
 		
 		if (this.pPartNames != null)	{
-			this.saveParameter(CQPPreferences.PARTNAMES, StringUtils.join(pPartNames, "\t"));
+			this.saveParameter(CQPPreferences.PART_NAMES, StringUtils.join(pPartNames, "\t"));
 		}
 		
 		if (this.pQueries != null)	{
@@ -802,5 +790,22 @@
 
 		return true;
 	}
+	
+	/**
+	 * Get the safe values (spacial char regexp safe).
+	 *
+	 * @param property the property
+	 * @param corpus the corpus
+	 * @return the safe values
+	 * @throws CqiClientException the cqi client exception
+	 */
+	private static List<String> getSafeValues(StructuralUnitProperty property, Corpus corpus) throws CqiClientException	{
+		List<String> values = property.getValues(corpus);
+		for(int i = 0 ; i < values.size() ; i++)
+			values.set(i, Query.addBackSlash(values.get(i)));
+		return values;
+	}
 
+
+
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 1025)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 1026)
@@ -154,14 +154,13 @@
 	 * @return the partition
 	 * @throws CqiClientException the cqi client exception
 	 */
-	public Partition createPartition(String name, List<String> queries,
-			List<String> partnames, boolean registered)
-					throws Exception {
+	public Partition createPartition(String name, List<String> queries, List<String> partnames, boolean registered) throws Exception {
 		Partition partition = new Partition(this);
 		partition.setParameters(name, queries, partnames);
 		partition.compute();
-		if (!registered)
+		if (!registered) {
 			partition.registerToParent();
+		}
 		return partition;
 	}
 
@@ -175,14 +174,13 @@
 	 * @return the partition
 	 * @throws CqiClientException the cqi client exception
 	 */
-	public Partition createPartition(String name, StructuralUnit structure,
-			StructuralUnitProperty property, List<String> values,
-			boolean registered) throws Exception {
+	public Partition createPartition(String name, StructuralUnit structure, StructuralUnitProperty property, List<String> values, boolean registered) throws Exception {
 		Partition partition = new Partition(this);
 		partition.setParameters(name, property, values);
 		partition.compute();
-		if (!registered)
+		if (!registered) {
 			partition.registerToParent();
+		}
 		return partition;
 	}
 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 1025)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 1026)
@@ -268,8 +268,7 @@
 	 */
 	public String getFullName() throws CqiClientException {
 		try {
-			return CorpusManager.getCorpusManager().getCqiClient()
-					.corpusFullName(this.cqpId);
+			return CorpusManager.getCorpusManager().getCqiClient().corpusFullName(this.cqpId);
 		} catch (Exception e) {
 			throw new CqiClientException(e);
 		}
@@ -285,8 +284,9 @@
 	 */
 	@Override
 	public WordProperty getProperty(String name) throws CqiClientException {
-		if (this.lexicalUnitsProperties == null)
+		if (this.lexicalUnitsProperties == null) {
 			getProperties();
+		}
 		
 		int idx = name.indexOf(".");
 		if (idx > 0) { // the name if a qualified name
@@ -294,8 +294,9 @@
 		}
 		
 		for (WordProperty property : this.lexicalUnitsProperties) {
-			if (property.getName().equals(name))
+			if (property.getName().equals(name)) {
 				return property;
+			}
 		}
 		return null;
 	}
@@ -308,13 +309,15 @@
 	 * .lang.String)
 	 */
 	@Override
-	public StructuralUnit getStructuralUnit(String name)
-			throws CqiClientException {
-		if (this.structuralUnits == null)
+	public StructuralUnit getStructuralUnit(String name) throws CqiClientException {
+		if (this.structuralUnits == null) {
 			getStructuralUnits();
-		for (StructuralUnit unit : this.structuralUnits)
-			if (unit.getName().equals(name))
+		}
+		for (StructuralUnit unit : this.structuralUnits) {
+			if (unit.getName().equals(name)) {
 				return unit;
+			}
+		}
 		return null;
 	}
 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPSearchEngine.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPSearchEngine.java	(revision 1025)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPSearchEngine.java	(revision 1026)
@@ -46,7 +46,9 @@
 	@Override
 	public boolean start(IProgressMonitor monitor) throws Exception {
 
-		if (monitor != null) monitor.subTask("Starting Corpus Engine...");
+		if (monitor != null) {
+			monitor.subTask("Starting Corpus Engine...");
+		}
 
 		boolean cqiserverok = false;
 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPPreferences.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPPreferences.java	(revision 1025)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPPreferences.java	(revision 1026)
@@ -1,7 +1,5 @@
 package org.txm.searchengine.cqp;
 
-import org.eclipse.core.runtime.preferences.DefaultScope;
-import org.osgi.framework.FrameworkUtil;
 import org.osgi.service.prefs.Preferences;
 import org.txm.core.preferences.TXMPreferences;
 
@@ -14,19 +12,27 @@
  */
 public class CQPPreferences extends TXMPreferences {
 	
-	// auto populate the preference node qualifier from the current bundle id
-	public static String PREFERENCES_NODE = FrameworkUtil.getBundle(CQPPreferences.class).getSymbolicName();
 
-	public static final String PREFERENCES_PREFIX = "cqp_"; //$NON-NLS-1$
-
 	/**
 	 * List of part names
 	 */
-	public static final String PARTNAMES = "part_names"; //$NON-NLS-1$
+	public static final String PART_NAMES = "part_names"; //$NON-NLS-1$
 	
+	
+	/**
+	 * Gets the instance.
+	 * @return the instance
+	 */
+	public static TXMPreferences getInstance()	{
+		if (!TXMPreferences.instances.containsKey(CQPPreferences.class)) {
+			new CQPPreferences();
+		}
+		return TXMPreferences.instances.get(CQPPreferences.class);
+	}
 
+
 	@Override
 	public void initializeDefaultPreferences() {
-		Preferences preferences = DefaultScope.INSTANCE.getNode(PREFERENCES_NODE);
+		Preferences preferences = this.getDefaultPreferencesNode();
 	}
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/importer/cwb/CwbEncode.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/importer/cwb/CwbEncode.java	(revision 1025)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/importer/cwb/CwbEncode.java	(revision 1026)
@@ -235,7 +235,7 @@
 		 */
 
 		// Warning !! for WINDOWS ONLY the "" value does not work with the ProcessBuilder we must set the value to "\"\""
-		String empty_value_code = TXMPreferences.getString(TBXPreferences.EMPTY_PROPERTY_VALUE_CODE, TBXPreferences.PREFERENCES_NODE);
+		String empty_value_code = Toolbox.getPreference(TBXPreferences.EMPTY_PROPERTY_VALUE_CODE);
 		if (OSDetector.isFamilyWindows()) {
 			if (empty_value_code == null) empty_value_code = "\"\"";
 			empty_value_code = empty_value_code.trim();
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/rcp/commands/R/OpenEmptyEditor.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/rcp/commands/R/OpenEmptyEditor.java	(revision 1025)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/rcp/commands/R/OpenEmptyEditor.java	(revision 1026)
@@ -34,6 +34,7 @@
 import org.eclipse.core.commands.ExecutionEvent;
 import org.eclipse.core.commands.ExecutionException;
 import org.eclipse.osgi.util.NLS;
+import org.txm.Toolbox;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.rcp.handlers.files.EditFile;
@@ -51,7 +52,7 @@
 	 */
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
-		File txmhome = new File(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.USER_TXM_HOME));
+		File txmhome = new File(Toolbox.getTxmHomePath());
 		File scripts = new File(txmhome, "scripts"); //$NON-NLS-1$
 		scripts.mkdir();
 		if (!scripts.exists())
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRScript.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRScript.java	(revision 1025)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRScript.java	(revision 1026)
@@ -47,6 +47,7 @@
 import org.eclipse.ui.IWorkbenchWindow;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.eclipse.ui.ide.FileStoreEditorInput;
+import org.txm.Toolbox;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.rcp.StatusLine;
@@ -110,7 +111,7 @@
 			}
 			dialog.setFilterExtensions(new String[] { "*.R" }); //$NON-NLS-1$
 
-			String scriptCurrentDir = TXMPreferences.getString(TBXPreferences.USER_TXM_HOME, TBXPreferences.PREFERENCES_NODE)+ "/scripts";
+			String scriptCurrentDir = Toolbox.getTxmHomePath() + "/scripts";
 			
 			dialog.setFilterPath(scriptCurrentDir);
 			result = dialog.open();
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/CheckRPackages.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/CheckRPackages.java	(revision 1025)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/CheckRPackages.java	(revision 1026)
@@ -156,7 +156,7 @@
 	
 	public static boolean installRPAckagesViaRscript() throws IOException {
 		String cmd = ""; //$NON-NLS-1$
-		String installPath = TXMPreferences.getString(TBXPreferences.INSTALL_DIR, TBXPreferences.PREFERENCES_NODE);
+		String installPath = Toolbox.getInstallDirectory();
 		if (Util.isMac() || Util.isLinux()) {
 			cmd = "R --no-save < \""+installPath+"/R/rlibs.R\""; //$NON-NLS-1$ //$NON-NLS-2$
 		} else if (Util.isWindows()) {
